defmodule FizzBuzz do
  def count(number) do
    1..number
    |> Enum.to_list
    |> Enum.map(&FizzBuzz.check/1)
  end

  def check(number) when number > 0 do
    cond do
      rem(number, 5) == 0 and rem(number, 3) == 0 ->
        "Fizzbuzz"
      rem(number, 5) == 0 ->
        "Buzz"
      rem(number, 3) == 0 ->
        "Fizz"
      true ->
        number
    end
  end
end

defmodule ElixirFizzbuzz do
  def upto(n) when n > 0, do: 1..n |> Enum.map(&fizzbuzz/1)

  def fizzbuzz(n), do: _fizzword(n, rem(n, 3), rem(n, 5))

  def _fizzword(n, 0, 0), do: "Fizzbuzz"
  def _fizzword(n, 0, _), do: "Fizz"
  def _fizzword(n, _, 0), do: "Buzz"
  def _fizzword(n, _, _) when n > 0, do: n
end

defmodule CaseFizzbuzz do
  def upto(n) when n > 0 do
    1..n
    |> Enum.map(&fizzbuzz/1)
  end

  def fizzbuzz(n) do
    current = {n, rem(n, 3), rem(n, 5)}
    case current do
      {n, 0, 0} -> "Fizzbuzz"
      {n, 0, _} -> "Fizz"
      {n, _, 0} -> "Buzz"
      {n, _, _} -> n
    end
  end
end
